// editNetworks.js

var networksError = false;

var networkTypeOptions = new Array;
networkTypeOptions['normal'] = 0;
networkTypeOptions['mac'] = 1;


function networkTypeSelectOptions()
{
  var output = '';
  for (var option in networkTypeOptions)
  {
    output += '    <option value="' + option + '">' + option + '</option>\n';
  }

  return output;
}

// define the <networks> arguments
nameLookups['networks'] = new Array;

createLookupEntry('networks', 'addr', 'Network', 'mixed', networkTypeSelectOptions(), 'Specify the Host entry that will be used in the Paths to identify source or destination machines, networks, etc. for the rules you create.');

function displayNetworksEntry(index)
{
  var output = '';
  var entry = dataObj.networks[index];
  
  output += '      <td align="right" width="2%"><a href="#" onClick="editNetworkEntry(\'' + index + '\'); return false;">' + index + '</a>&nbsp;</td>\n';
  output += '      <td align="left" width="25%">' + fixupOutput(entry.host) + '</td>\n';
  output += '      <td align="center" width="20%">' + fixupOutput(entry.type) + '</td>\n';
  output += '      <td align="center" width="20%">' + (entry.active ? 'true' : 'false') + '</td>\n';
  output += '      <td align="left" width="25%">' + fixupOutput(entry.comment) + '</td>\n';
  output += '      <td align="center" width="8%"><a href="#" onClick="deleteNetworkEntry(\'' + index + '\'); return false;">Delete</a></td>\n';

  return output;
}

function displayNetworks()
{
  var content = getContent();

  if (! verifyChangesSaved())
  {
    return;
  }
  entryChangesMade = false;

  displayStatus("Editing Networks...<br>\nClick on the Index number of the entry to edit, the <b>Delete</b> link to Delete an entry or the <b>Create</b> button to create a new entry.", "info");

  // build up the form html to display the dataObj.networks info in.
  var html = "";
  html += '  <center><b>Networks</b></center><br>\n';
  html += '  <center><input type="button" name="create" value="Create" onClick="createNetworkEntryScreen();"></center>\n';
  html += '  <table border="0" width="100%" cellpadding="0" cellspacing="2">\n';
  html += '    <tr>\n';
  html += '      <th align="center">Index</th><th align="center">Host</th><th align="center">Type</th><th align="center">Active</th><th align="center">Comment</th><th>&nbsp;</th>\n';
  html += '    </tr>\n';
  var counter = true;
  for (var n=0; n < dataObj.networks.length; n++)
  {
    if (dataObj.networks[n] != null)
    {
      var color = (counter ? "lightblue" : "white");
      html += '    <tr bgcolor="' + color + '">\n';
      html += displayNetworksEntry(n);
      html += '    </tr>\n';
      counter = !counter;
    }
  }
  html += '  </table>\n';
  html += '  <br>\n';
  html += '  <center><input type="button" name="create" value="Create" onClick="createNetworkEntryScreen();"></center>\n';

  content.innerHTML = html;
}

function displayNetworkEntry(mode, index)
{
  var content = getContent();
  var config = document.configF;
  var networks = dataObj.networks;
  var entry;

  if (mode != "Create")
  {
    entry = networks[index];
  }
  else
  {
    entry = new createNetworkEntry("", "normal", 0, 0, "");
  }

  displayStatus(mode + (mode != "Create" ? "ing" : "") + " Network Entry" + (mode != "Create" ? ' ' + index : '') + "...", "info");

  // build up the form html to display the dataObj.networks info in.
  var html = "";
  html += '  <input type="hidden" name="index" value="' + index + '">\n';
  html += '  <center><b>' + mode + ' Network Entry' + (mode != "Create" ? ' ' + index : '') + '</b></center><br>\n';
  html += '  <table border="0" width="100%" cellpadding="0" cellspacing="2">\n';
  html += '    <tr>\n';
  html += '      <th align="center">Index</th><th align="center">Host</th><th align="center">Type</th><th align="center">Active</th><th align="center">Comment</th>\n';
  html += '    </tr>\n';
  html += '    <tr>\n';
  html += '      <td align="center" width="10%"><a href="#" onClick="displayHelp(\'networks\', \'addr\'); return false;">' + (mode != "Create" ? index : "&nbsp;") + '</a>&nbsp;</td>\n';
  html += '      <td align="center" width="25%"><input type="text" name="host" value="' + entry.host + '" onChange="entryChangesMade=true;" onKeyPress="entryChangesMade=true;"></td>\n';
  html += '      <td align="center" width="20%">\n';
  html += '        <select name="type" onChange="entryChangesMade=true;">\n';
  html += networkTypeSelectOptions();
  html += '        </select>\n';
  html += '      </td>\n';
  html += '      <td align="center" width="20%">\n';
  html += '        <select name="active" onChange="entryChangesMade=true;">\n';
  html += trueFalseSelectOptions();
  html += '        </select>\n';
  html += '      </td>\n';
  html += '      <td align="center" width="25%"><input type="text" name="comment" value="' + entry.comment + '" onChange="entryChangesMade=true;" onKeyPress="entryChangesMade=true;"></td>\n';
  html += '    </tr>\n';
  html += '  </table>\n';
  html += '  <br>\n';
  html += '  <center><input type="button" name="update" value="Update" onClick="updateNetworkEntry(\'' + mode + '\', \'' + index + '\');"></center>\n';

  content.innerHTML = html;

  // initialize the settings.
  config.type.selectedIndex = networkTypeOptions[entry.type];
  config.active.selectedIndex = boolSelectIndex(entry.active);
}

function editNetworkEntry(index)
{
  displayNetworkEntry('Edit', index);
}

function deleteNetworkEntry(index)
{
  var networks = dataObj.networks;
  var result = confirm("Are you sure you want to Delete Network entry " + index + "?");
  if (result == false)
  {
    return;
  }
  var hostInUse = 0;
  var zoneCount = 0;
  var pathCount = 0;

  // verify the entry exists.
  if (networks[index] == null)
  {
    alert("Network Entry '" + index + "' does not exist to Delete!");
  }
  // delete the entry.
  else
  {
    // first verify we are not being used at all in zones.
    var zones = dataObj.zones;
    for (var zone in zones)
    {
      // process each entry in this zone and look at the network array.
      for (var alias in zones[zone])
      {
        var network = zones[zone][alias].network;
        for (var hostIndex in network)
        {
          if (network[hostIndex] == index)
          {
            zoneCount++;
            break;
          }
        }
        network = zones[zone][alias].ipsecLimitFrom;
        for (var hostIndex in network)
        {
          if (network[hostIndex] == index)
          {
            zoneCount++;
            break;
          }
        }
      }
    }

    // next verify we are not being used in paths.
    pathCount = findInUsePaths('network', index);

    hostInUse = zoneCount + pathCount;

    var deleteNetwork = true;
    if (zoneCount > 0)
    {
      alert("You can not Delete Network Entry '" + index + "' as it is used " + zoneCount + " times in the Zones section!");
      deleteNetwork = false;
    }
    result = deleteInUsePaths('network', index);
    if (result == false)
    {
      return;
    }
    if (deleteNetwork)
    {
      delete networks[index];
      changesMade = true;
    }
  }

  // redisplay the Networks screen.
  displayNetworks();
}

function createNetworkEntryScreen()
{
  displayNetworkEntry('Create', -1);
}

function updateNetworkEntry(mode, index)
{
  var config = document.configF;
  var networks = dataObj.networks;
  var entry;

  if (mode != "Create")
  {
    entry = networks[index];
  }
  else
  {
    entry = new createNetworkEntry("", "normal", 0, 0, "");
  }

  if (isTrueSelect(config.active.selectedIndex) != entry.active)
  {
    entryChangesMade = true;
    entry.active = isTrueSelect(config.active.selectedIndex);
  }
  if (config.host.value != entry.host)
  {
    entryChangesMade = true;
    entry.host = config.host.value;
  }
  if (config.comment.value != entry.comment)
  {
    entryChangesMade = true;
    entry.comment = config.comment.value;
  }
  if (config.type.selectedIndex != networkTypeOptions[entry.type])
  {
    entryChangesMade = true;
    entry.type = config.type.options[config.type.selectedIndex].value;
  }
  
  if (entry.host.length == 0)
  {
    alert("You must specify a host value!");
    networksError = true;
  }

  if (networksError)
  {
    // reset the error flag.
    networksError = false;
  }
  else
  {
    if (mode == "Create")
    {
      // figure out the index to insert at (try to fill in any empty holes).
      for (var i=0; i < networks.length; i++)
      {
        if (networks[i] == null)
        {
          index = i;
          break;
        }
      }
      if (index == -1)
      {
        index = networks.length;  // point to the last entry.
      }
    }
    networks[index] = entry;
    if (entryChangesMade)
    {
      changesMade = true;
      entryChangesMade = false;
    }
    displayNetworks();
  }
}
